<?php
/**
 * Order
 *
 * @class    edd_esignature
 * @version  2.2.0
 * @package  esig-edd
 * @category Class
 * @author   approveme
 */

class esig_edd_sad {
	
	
	 function __construct() {
		
		global $wpdb;
		$this->wpdb = $wpdb;
		
		$this->dbtable =   $this->wpdb->prefix . 'esign_documents_stand_alone_docs';
		    
	}
	
	 /**
	  *  get sad page array
	  * 
	  *  @since 1.0.0
	  */ 
	  public function esig_get_sad_pages()
		{
			if(! function_exists('WP_E_Sig'))
				return ;
				
		$api = WP_E_Sig();
                
                if(!method_exists($api->document,'getTitle')){
                    return ;
                }
		
		$stand_alone_pages = $this->wpdb->get_results("SELECT page_id, document_id FROM {$this->dbtable}", OBJECT_K);
			
			$edd_array=array();
			
			$edd_array['pleaseslc']=__("Please Select Agreement Document","edd-esig"); 
			
			foreach($stand_alone_pages as $sad_page)
			{
				$document_status=$api->document->getStatus($sad_page->document_id); 
				
				if($document_status !='trash')
				{
					if('publish' === get_post_status($sad_page->page_id ))
					{
						$edd_array[$sad_page->page_id]= $api->document->getTitle($sad_page->document_id);    //get_the_title($sad_page->page_id );
					}
				}
				
			}
			
			return $edd_array ; 
		}
		
		
	
	/**
	 *  Get sad page id by document id 
	 * 
	 *  @since 1.0.0
	 */ 
	
	public function get_sadpage_id_document_id($id)
	{
		return $this->wpdb->get_var(
			$this->wpdb->prepare(
				"SELECT page_id FROM " . $this->dbtable . " WHERE document_id=%s", $id
				)
			);
	}
	
	/**
	 *  Get sad document id by page id 
	 * 
	 *  @since 1.0.0
	 */ 
	
	public function get_sad_document_id($page_id)
	{
		return $this->wpdb->get_var(
			$this->wpdb->prepare(
				"SELECT max(document_id) FROM " . $this->dbtable . " WHERE page_id=%s", $page_id
				)
			);
	}
	
	/**
	*  Check sad page is active and document is valid. 
	*/
	public function is_agreement_page_valid($page_id)
	{
		if(! function_exists('WP_E_Sig'))
				return ;
					
		$document_id = $this->get_sad_document_id($page_id);
		if(WP_E_Sig()->document->document_exists($document_id) == 0)
		{
			return false ; 
		}
		$document_status=WP_E_Sig()->document->getStatus($document_id); 
				
				if($document_status !='trash')
				{
					
					return true ;
				}
				else 
				{
					return false ;
				}
		return false ; 
	}
	
}