<?php

class esigEddData {

    protected static $instance = null;

    public static function instance() {
       
        // If the single instance hasn't been set, set it now.
        if (null == self::$instance) {
            self::$instance = new self;
        }

        return self::$instance;
    }

    private function __construct() {
      
        add_filter('esig_sif_buttons_filter', array($this, 'add_sif_gravity_buttons'), 10, 1);
        add_filter('esig_text_editor_sif_menu', array($this, 'add_sif_gf_text_menu'), 10, 1);
        add_filter('esig_admin_more_document_contents', array($this, 'document_add_data'), 10, 1);
        add_action('admin_enqueue_scripts', array($this, 'enqueue_admin_scripts'));
    }

    public function enqueue_admin_scripts() {

        $screen = get_current_screen();
        $admin_screens = array(
            'admin_page_esign-add-document',
            'admin_page_esign-edit-document',
        );

        // Add/Edit Document scripts
        if (in_array($screen->id, $admin_screens)) {

            // wp_enqueue_style( $this->plugin_slug . '-admin-style', plugins_url( 'assets/css/esig_template.css', __FILE__ ));
            wp_enqueue_script('jquery');
            wp_enqueue_script('esig-edd-admin-script', ESIGN_EDD_URL . '/assets/js/esig-edd.js', array('jquery', 'jquery-ui-dialog'), esigGetVersion(), true);
        }
    }

    public function add_sif_gravity_buttons($sif_menu) {

        $esig_type = ESIG_GET('esig_type');
        $document_id = ESIG_GET('document_id');
        if (empty($esig_type) && !empty($document_id)) {
            $document_type = WP_E_Sig()->document->getDocumenttype($document_id);
            if ($document_type == "stand_alone") {
                $esig_type = "sad";
            }
        }
        if ($esig_type != 'sad') {
            return $sif_menu;
        }
        // $plugins['esig_sif'] = plugin_dir_url(__FILE__) . 'assets/js/esig-gravity-sif-buttons.js';
        $sif_menu .='{text: "Insert EDD Details",value: "edd",onclick: function () {  tb_show( "+ Insert EDD Details", "#TB_inline?width=500&height=300&inlineId=esig-edd-option");esign.tbSize(450);}},';

        return $sif_menu;
    }

    public function add_sif_gf_text_menu($sif_menu) {

        $esig_type = ESIG_GET('esig_type');
        $document_id = ESIG_GET('document_id');

        if (empty($esig_type) && !empty($document_id)) {
            $document_type = WP_E_Sig()->document->getDocumenttype($document_id);
            if ($document_type == "stand_alone") {
                $esig_type = "sad";
            }
        }

        if ($esig_type != 'sad') {
            return $sif_menu;
        }
        $sif_menu['edd'] = array('label' => "Insert EDD Details");
        return $sif_menu;
    }

    final function document_add_data($more_option_page) {


       // $more_option_page = '';
        $assets_dir = ESIGN_ASSETS_DIR_URI;

        $more_option_page .= '<div id="esig-edd-option" class="esign-form-panel" style="display:none;">
        	        
        	        
                	               <div align="center"><img src="' . $assets_dir . '/images/logo.png" width="200px" height="45px" alt="Sign Documents using WP E-Signature" width="100%" style="text-align:center;"></div>
                    			
                                    
                    				<div id="esig-edd-form-first-step">
                        				
                                        	<h3 class="esign-form-header">' . __('Insert available EDD tag to contract.', 'esig-edd') . '</h3>
                                            	
                        				<p id="create_gravity" align="center">';

        $more_option_page .= '
                        			
                        				<p id="select-gravity-form-list" align="center">
                                	    
                        		        <select data-placeholder="Choose a Option..." class="chosen-select" tabindex="2" id="esig-edd-tag" name="esig-edd-tag">
                        			     <option value="sddelect">' . __('Insert EDD shorcode', 'esig-edd') . '</option>';

        $tags = $this->eddTag();

        foreach ($tags as $value => $label) {

            $more_option_page .= '<option value="' . $value . '">' . $label . '</option>';
        }

        $more_option_page .='</select>
                                	    
                        				</p>
                         	  
                                	    </p>
                                	    
                                        <p id="upload_gravity_button" align="center">
                                           <a href="#" id="esig-insert-edd-tag" class="button-primary esig-button-large">' . __('Insert Details', 'esig-edd') . '</a>
                                         </p>
                                     
                                    </div>  <!-- Frist step end here  --> ';

        $more_option_page .= '</div><!--- gravity option end here -->';


        return $more_option_page;
    }

    private function eddTag() {
        
       $result = array(
           "payment_key"=> "Payment key",
           "payment_currency"=>"Payment currency",
           "payment_gateway"=> "Payment gateway" ,
           "payment_date"=> "Payment date",   
           "wpuser_first_name"=>"Wordpress user first name",
           "wpuser_last_name"=> "Wordpress user last name",
           "wpuser_email"=>"Wordpress user e-mail address",     
           "customer_email" =>"Customer E-mail" , 
           "customer_ip_address" => "Customer ip address",
           "customer_first_name"=>"Customer first name",
           "customer_last_name"=>"Customer last name",    
           "transaction_id"=>"Transaction id", 
           "payment_total" => "Payment total" , 
           "payment_subtotal" =>  "Payment subtotal",
           "payment_tax" =>"Payment tax",
           "payment_discount" =>"Payment discount", 
           "payment_status"=>"Payment status",    
           );
       
        // order product details .
        $items = get_posts(array('post_type' => 'download','post_status'=>'publish'));

        if ($items) {
            foreach ($items as $itemId => $itemData) {
                $result['download_' . $itemData->ID . '_name'] = $itemData->post_title;
                $result['download_' . $itemData->ID . '_quantity'] = $itemData->post_title . " quantity";
            }
        }
        return $result;
    }

}
